const webpack = require('webpack')
module.exports = {
  /**
   * 文档配置：详情请查看文档 https://cli.vuejs.org/zh/config/#vue-config-js
   * 配置文档中没有写的，都按文档默认值打包
   * 
   * publicPath 部署应用包时的基本 URL。
   * 默认情况下，Vue CLI 会假设你的应用是被部署在一个域名的根路径上，例如 https://www.my-app.com/。
   * 如果你的应用被部署在 https://www.my-app.com/my-app/，则设置 publicPath 为 /my-app/。
   */
  pages: {
    index: {
      // page 的入口
      entry: 'packages/main.ts',
      // 模板来源
      template: 'public/index.html',
      // 在 dist/index.html 的输出
      filename: 'index.html',
      // 当使用 title 选项时，
      // template 中的 title 标签需要是 <title><%= htmlWebpackPlugin.options.title %></title>
      title: 'Index Page',
      // 在这个页面中包含的块，默认情况下会包含
      // 提取出来的通用 chunk 和 vendor chunk。
    },
  },

  // 生产环境关闭eslint检查
  lintOnSave: process.env.NODE_ENV !== 'production',
  productionSourceMap: false,

  //引入jquery
  chainWebpack: config => {
    config.plugin('provide').use(webpack.ProvidePlugin, [{
      $: 'jquery',
      jquery: 'jquery',
      jQuery: 'jquery',
      'window.jQuery': 'jquery'
    }])
    config.module
      .rule("js")
      .include.add("/packages/")
      .end()
      .use("babel")
      .loader("babel-loader")
      .tap(options => {
        // 修改它的选项...
        return options;
      });
  },
  parallel: false,
  // 关闭打包生成的map文件
  productionSourceMap: false,
  // 强制CSS内联
  css: {
    extract: false
  }
}
